package com.benyun.core.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.benyun.core.dao.TopologicalBuildWdDao;
import com.benyun.core.dao.TopologicalBuildWdStatisticsCategoryDao;
import com.benyun.core.entity.TopologicalBuildWdStatisticsCategory;
import com.benyun.core.entity.TopologicalBuildingWd;
import com.benyun.core.entity.TopologicalStoreWd;
import com.benyun.core.entity.TopologicalStoreWdStatisticsCategory;
import com.benyun.core.entity.bo.BuildWdCategoryCount;
import com.benyun.core.entity.bo.StoreWdCategoryCount;
import com.benyun.core.entity.bo.StoreWdCategoryCountBody;
import com.benyun.core.entity.vo.TopologicalWdAceeptVo;
import com.benyun.core.service.TopologicalBuildWdSerevice;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

@Service
@Transactional
public class TopologicalBuildWdSereviceImpl implements TopologicalBuildWdSerevice {

    @Autowired
    TopologicalBuildWdDao topologicalBuildWdDao;

    @Autowired
    TopologicalBuildWdStatisticsCategoryDao topologicalBuildWdStatisticsCategoryDao;

    @Override
    public List<BuildWdCategoryCount> buildingLevel(TopologicalWdAceeptVo topologicalWdAceeptVo) {
        QueryWrapper<TopologicalBuildWdStatisticsCategory> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("center_wd_id",topologicalWdAceeptVo.getCenterWdId());
        queryWrapper.and(wrapper -> {
            wrapper.eq("radius",topologicalWdAceeptVo.getRadius());
        });

        List<BuildWdCategoryCount> list = new ArrayList<>();
        TopologicalBuildWdStatisticsCategory topologicalBuildWdStatisticsCategory = topologicalBuildWdStatisticsCategoryDao.selectOne(queryWrapper);
        String propertyTypeStatistics = topologicalBuildWdStatisticsCategory.getPropertyTypeStatistics();
        int total = 0;
        for (String s : propertyTypeStatistics.split(";")) {
            BuildWdCategoryCount buildWdCategoryCount = new BuildWdCategoryCount();
            String[] split = s.split(":");
            if (split.length !=2)
                continue;
            buildWdCategoryCount.setName(split[1]);
            buildWdCategoryCount.setCount(Integer.parseInt(split[1]));
            total+=buildWdCategoryCount.getCount();
            list.add(buildWdCategoryCount);
        }
        for (BuildWdCategoryCount buildWdCategoryCount : list) {
            buildWdCategoryCount.setRadio(buildWdCategoryCount.getCount()/total);
        }
        return list;
    }

    @Override
    public PageInfo<TopologicalBuildingWd> list(TopologicalWdAceeptVo topologicalWdAceeptVo) {
        PageHelper.startPage(topologicalWdAceeptVo.getPageNum(), topologicalWdAceeptVo.getPageSize());
        List<TopologicalBuildingWd> topologicalStoreWds = topologicalBuildWdDao.list(topologicalWdAceeptVo.getCenterWdId(), Integer.valueOf(topologicalWdAceeptVo.getRadius()));
        PageInfo<TopologicalBuildingWd> pageInfo = new  PageInfo<>(topologicalStoreWds);

        return pageInfo;
    }
}
